/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * $Id: GetJasmineEventNotificationMessage.java 5134 2009-09-03 09:21:59Z alitokmen $
 */
package org.ow2.jasmine.monitoring.eventswitch.transformers;

import org.mule.transformers.AbstractTransformer;
import org.mule.umo.transformer.TransformerException;
import org.ow2.jasmine.event.beans.JasmineEventNotification;


/**
 * Gets a JASMINe event notification's message.
 */
public class GetJasmineEventNotificationMessage extends AbstractTransformer {

    /**
     * Registers the transformer on Mule.
     *
     * @see org.mule.transformers.AbstractTransformer
     */
    public GetJasmineEventNotificationMessage() {
        super();
        this.registerSourceType(JasmineEventNotification.class);
        this.setReturnClass(String.class);
    }


    /**
     * Gets a JASMINe event notification's message.
     *
     * @param src      @see org.mule.transformers.AbstractTransformer.doTransform
     * @param encoding @see org.mule.transformers.AbstractTransformer.doTransform
     *
     * @return src's message attribute.
     */
    @Override
    protected Object doTransform(final Object src, final String encoding) throws TransformerException {

        if (src instanceof JasmineEventNotification) {
            JasmineEventNotification event = (JasmineEventNotification) src;

            return event.getMessage();
        } else {
            throw new IllegalArgumentException("Unable to transform this source type: " + src.getClass().getName());
        }

    }

}
